VERSION 5.00
Begin VB.UserControl SpinControl 
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   930
   Picture         =   "SpinControl.ctx":0000
   ScaleHeight     =   285
   ScaleWidth      =   930
   Begin VB.CommandButton cmdMinus 
      BackColor       =   &H00E0E0E0&
      Caption         =   "-"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   680
      MaskColor       =   &H00E0E0E0&
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton cmdPlus 
      BackColor       =   &H00E0E0E0&
      Caption         =   "+"
      Height          =   285
      Left            =   0
      MaskColor       =   &H00E0E0E0&
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   0
      Width           =   255
   End
   Begin VB.TextBox txtSpinBoxValue 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H000000C0&
      ForeColor       =   &H00FFFFFF&
      Height          =   285
      Left            =   240
      Locked          =   -1  'True
      MaxLength       =   3
      TabIndex        =   0
      Top             =   0
      Width           =   430
   End
End
Attribute VB_Name = "SpinControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
'================================================================
'               Program Author: Krishna Kumar Khatri
'             2004, http://khatri-krishna.tripod.com
'                        KSpinControl.vbp
'================================================================

'Default Property Values:
Const m_def_Min = 0
Const m_def_Max = 900
Const m_def_Interval = 5

'Property Variables:
Dim m_Min As Integer
Dim m_Max As Integer
Dim m_Interval As Integer

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Min() As Integer
Attribute Min.VB_Description = "The minimum value for Spin box."
    Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Integer)
    If New_Min >= 0 Then
        If New_Min > m_Max Then
            MsgBox "Error setting property... Invalid value. Value can't be greater than the Max.", vbOKOnly + vbExclamation, "Error"
        Else
            m_Min = New_Min
            PropertyChanged "Min"
            txtSpinBoxValue.Text = Min
        End If
    Else
        MsgBox "Error setting property... Invalid value. Specifiy a value >= 0.", vbOKOnly + vbExclamation, "Error"
    End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Max() As Integer
Attribute Max.VB_Description = "The maximum value for Spin box."
    Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Integer)
    If New_Max <= 999 Then
        If New_Max < m_Min Then
            MsgBox "Error setting property... Invalid value. Value can't be less than the Min.", vbOKOnly + vbExclamation, "Error"
        Else
            m_Max = New_Max
            PropertyChanged "Max"
        End If
    Else
        MsgBox "Error setting property... Invalid value. Specify a value < 999.", vbOKOnly + vbExclamation, "Error"
    End If
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Interval() As Integer
Attribute Interval.VB_Description = "The amount by which the counter should increment."
    Interval = m_Interval
End Property

Public Property Let Interval(ByVal New_Interval As Integer)
    If New_Interval > 0 Then
        If New_Interval < (m_Max - m_Min) Then
            m_Interval = New_Interval
            PropertyChanged "Interval"
        Else
            MsgBox "Error setting property... Invalid value. Specify a valud < (Max - Min).", vbOKOnly + vbExclamation, "Error"
        End If
    Else
        MsgBox "Error setting property... Invalid value. Specifiy a value > 0.", vbOKOnly + vbExclamation, "Error"
    End If
End Property

Private Sub cmdMinus_Click()
    With txtSpinBoxValue
        If .Text > m_Min Then
            .Text = Val(.Text) - m_Interval
        End If
        .SetFocus
        .SelStart = Len(.Text)
    End With
End Sub

Private Sub cmdPlus_Click()
    With txtSpinBoxValue
        If .Text < m_Max Then
            .Text = Val(.Text) + m_Interval
        End If
        .SetFocus
        .SelStart = Len(.Text)
    End With
End Sub

Private Sub txtSpinBoxValue_KeyPress(KeyAscii As Integer)
    If Not IsNumeric(Chr(KeyAscii)) Then
        KeyAscii = 0
    End If
End Sub

Private Sub UserControl_Initialize()
    txtSpinBoxValue.Text = Min
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Min = m_def_Min
    m_Max = m_def_Max
    m_Interval = m_def_Interval
End Sub

Private Sub UserControl_Paint()
    Call ResizeControl
    txtSpinBoxValue.Text = m_Min
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Min = PropBag.ReadProperty("Min", m_def_Min)
    m_Max = PropBag.ReadProperty("Max", m_def_Max)
    m_Interval = PropBag.ReadProperty("Interval", m_def_Interval)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
    Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
    Call PropBag.WriteProperty("Interval", m_Interval, m_def_Interval)
End Sub

Private Sub ResizeControl()
    With UserControl
        .Width = 930
        .Height = 285
    End With
End Sub
